#!/usr/bin/env python3
import isce, shelve, os, subprocess, shutil
#--------------Set params-----
cwd = os.getcwd()
resampdir = cwd
prjdir, xxx = os.path.split(cwd)
zerodir = os.path.join(prjdir, '0_make_ann_dem')
isceprocdir = os.path.join(prjdir, 'SLC')
offsetsdir = os.path.join(prjdir, 'offsets')
postprocdir = os.path.join(prjdir, '3_postprocess_stacks')

mSlcl = sorted([f for f in os.listdir(os.path.join(zerodir, 'ARCHIVED_FILES')) if f.endswith('.zip')])
masterSlc = mSlcl[0]#+'.slc'
masterdate = '20' + masterSlc.split('-')[1].split('.')[0]
#-------------------------------

p2res = [f for f in os.listdir(zerodir) if f.isnumeric() and masterdate not in f]
print(p2res)

if len(p2res)==0:
    print('=====Skipping resampleSlc.py, no new slc images=====')

for num, val in enumerate(p2res):
    print('=======resampleSlc.py for: ' +val+'=======')
    subprocess.call(['resampleSlc.py', '-m', os.path.join(isceprocdir,masterdate), '-s', os.path.join(isceprocdir,val), '-o', os.path.join(resampdir,val), '-f', os.path.join(offsetsdir,val), '--noflat'])

for num, val in enumerate(p2res):
    if not os.path.exists(os.path.join(postprocdir,val)):
        os.mkdir(os.path.join(postprocdir,val))
    shutil.move(os.path.join(resampdir, val, val+'.slc'), os.path.join(postprocdir, val, val+'.slc'))
    shutil.move(os.path.join(resampdir, val, val+'.slc.vrt'), os.path.join(postprocdir, val, val+'.slc.vrt'))
    shutil.move(os.path.join(resampdir, val, val+'.slc.xml'), os.path.join(postprocdir, val, val+'.slc.xml'))
    shutil.rmtree(os.path.join(resampdir,val))

for num, val in enumerate(p2res):
    os.chdir(os.path.join(postprocdir,val))
    subprocess.call(['fixImageXml.py', '-i', val+'.slc', '-f'])
